﻿using Microsoft.Win32.SafeHandles;
using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace CSharpLib
{
    [Guid("8EA9EAA8-CA3D-4584-B1E0-7B9561757CA4")]
    public interface ICSharpLibrary
    {
        int[] GetData();
        string GetName();
        bool Init();
    }
    [Guid("B62A2B51-621D-41AA-8F4F-021E404B593C")]
    public class CSharpLibrary : ICSharpLibrary, IDisposable
    {
        private bool disposed = false;
        private int[] data;
        private string name = "CSharpLib";
        private SafeHandle safeHandle = new SafeFileHandle(IntPtr.Zero, true);

        private void MakeData()
        {
            var list = new List<int>();
            var rnd = new Random();
            for(var i = 0; i < 1000; i++)
            {
                list.Add(rnd.Next(0, 255));
            }

            data = list.ToArray();
        }

        public int[] GetData()
        {
            MakeData();
            return data;
        }

        public string GetName()
        {
            return name;
        }

        public bool Init()
        {
            data = null;

            return true;
        }

        public void Dispose()
        {
            Dispose(true);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (disposed)
            {
                return;
            }
            if (disposing)
            {
                data = null;
                safeHandle.Dispose();
            }

            disposed = true;
        }
    }
}
